import { __decorate, __metadata } from "tslib";
import { MdcComponent, booleanAttr, defaultSlotProcessContent } from '@aurelia2-mdc-web/base';
import { helperTextCssClasses, MDCSelectHelperTextFoundation } from '@material/select';
import { customElement, inject, bindable } from 'aurelia';
import { processContent } from '@aurelia/runtime-html';
export const mdcHelperTextCssClasses = {
    ROOT: 'mdc-select-helper-text'
};
let MdcSelectHelperText = class MdcSelectHelperText extends MdcComponent {
    helperTextCssClasses = helperTextCssClasses;
    ROOT = mdcHelperTextCssClasses.ROOT;
    persistent;
    validation;
    errors;
    attachedPromise = this.createAttachedPromise();
    attachedPromiseResolve;
    async createAttachedPromise() {
        return new Promise(r => this.attachedPromiseResolve = r);
    }
    attached() {
        this.attachedPromiseResolve();
    }
    detached() {
        this.attachedPromise = this.createAttachedPromise();
    }
    // Provided for access by MDCTextField component
    get foundationForTextField() {
        return this.foundation;
    }
    getDefaultFoundation() {
        // DO NOT INLINE this variable. For backward compatibility, foundations take a Partial<MDCFooAdapter>.
        // To ensure we don't accidentally omit any methods, we need a separate, strongly typed adapter variable.
        const adapter = {
            addClass: (className) => this.root.classList.add(className),
            removeClass: (className) => this.root.classList.remove(className),
            hasClass: (className) => this.root.classList.contains(className),
            getAttr: (attr) => this.root.getAttribute(attr),
            setAttr: (attr, value) => this.root.setAttribute(attr, value),
            removeAttr: (attr) => this.root.removeAttribute(attr),
            setContent: (content) => {
                this.root.textContent = content;
            },
        };
        return new MDCSelectHelperTextFoundation(adapter);
    }
};
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], MdcSelectHelperText.prototype, "persistent", void 0);
__decorate([
    bindable({ set: booleanAttr }),
    __metadata("design:type", Boolean)
], MdcSelectHelperText.prototype, "validation", void 0);
__decorate([
    bindable,
    __metadata("design:type", Array)
], MdcSelectHelperText.prototype, "errors", void 0);
MdcSelectHelperText = __decorate([
    inject(Element),
    customElement('mdc-select-helper-text'),
    processContent(defaultSlotProcessContent)
], MdcSelectHelperText);
export { MdcSelectHelperText };
//# sourceMappingURL=mdc-select-helper-text.js.map